
package de.ivu.elect.presentation.search;

import static org.apache.commons.lang3.StringUtils.isBlank;

import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.search.entity.BenutzerSuchparameter;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId("493")
@ViewAccessScoped
@Named(AbstractBenutzerSuchparameterSearchView.COMPONENT_NAME)
@View(viewId = AbstractBenutzerSuchparameterSearchView.VIEW_ID, useCase = UseCasePermission.BENUTZER_SUCHPARAMETER_SEARCH)
public class BenutzerSuchparameterSearchView extends AbstractBenutzerSuchparameterSearchView {

  private static final long serialVersionUID = 1L;

  @Inject
  @ConversationGroup(BenutzerSuchparameterSearchViewStore.class)
  private transient BenutzerSuchparameterSearchViewStore benutzerSuchparameterSearchViewStore;

  public BenutzerSuchparameterSearchView() {
    super();
  }

  @Nullable
  @PreConditionCheck
  public String checkPreCondition() {
    if (isBlank(benutzerSuchparameterSearchViewStore.getSuchparameterViewId()) || !isWahlSelected() && !isWahlterminSelected()) {
      return getStartViewId();
    }

    return null;
  }

  @Override
  protected AbstractGebietSecurityFilter<BenutzerSuchparameter> getGebietSecurityFilter() {
    return KEIN_GEBIET_SECURITY_FILTER;
  }

  @Override
  public void presetSearchParameters() {
    if (isWahlSelected()) {
      Wahl wahl = getSelectedWahl();

      getSearchParameters().setWahl(wahl);
      getSearchParameters().setWahltermin(wahl.getWahltermin());
    } else {
      getSearchParameters().setWahltermin(getSelectedWahltermin());
    }

    getSearchParameters().setBenutzerkennung(getSelectedBenutzerKennung());
    getSearchParameters().setViewId(benutzerSuchparameterSearchViewStore.getSuchparameterViewId());
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    // nichts zu tun...
  }

  @Override
  public boolean isOptionMenuRendered() {
    return false;
  }

  @Override
  public boolean isBtnResetRendered() {
    return false;
  }

  @Override
  public boolean isBtnGoBackRendered() {
    return true;
  }

  @Nullable
  @Override
  @Redirect
  public String goBack() {
    benutzerSuchparameterSearchViewStore.setSuchparameterViewId(null);

    return super.goBack();
  }
}
